/* Info>>>>
 * This school project for MPOA is made from various different libraries and parts of projects by Cahya Wirawan, Benjamin,
 * Tilen Majerle, Helix library group and STM32 libraries. All of the libraries are free under MIT licence expect STM32 libraries.
 * Most of the libraries are now current so they dont use HAL.
 *
 * MP3 decoding is free to use from year 2017
 *
 *  */

#include "string.h"
#include "stdio.h"
#include "main.h"
#include "stm32f4xx.h"
/* STM32f4 libraries created by Tilen Majerle */
#include "tm_stm32f4_disco.h"
#include "tm_stm32f4_delay.h"
#include "tm_stm32f4_usart.h"
#include "tm_stm32f4_lis302dl_lis3dsh.h"
#include "tm_stm32f4_fatfs.h"
#include "tm_stm32f4_usb_msc_host.h"
#include "play_FILE.h"

void hwInit();

int main(void)
{
    hwInit();

    while(1)
    {
        TM_USB_MSCHOST_Process();
        if (TM_USB_MSCHOST_Device() == TM_USB_MSCHOST_Result_Connected)
        {
            while(1)
            {
        	    playFromUSB("1:");
            }
        }
    }
}

void hwInit()
{
	if (SysTick_Config(SystemCoreClock / 1000))
	{
		while (1)
		{
			/* If it returns 1, there is error, do not contuniu and wait in loop */
		};
	}

    TM_DELAY_Init();                                     /* Initialize delay  */
	TM_DISCO_LedInit();                                  /* Initialize LEDs */
    TM_USART_Init(USART2, TM_USART_PinsPack_1, 115200);  /* Initialize USART2 at 115200 baud, TX: PA2, RX: PA3 */
	TM_DISCO_ButtonInit();                               /* Initialize buttons on board */
    TM_USB_MSCHOST_Init();                               /* Initialize USB MSC HOST */
    
    if (TM_LIS302DL_LIS3DSH_Detect() == TM_LIS302DL_LIS3DSH_Device_LIS3DSH)
    {
        TM_DISCO_LedOn(LED_BLUE); 														/* Turn on BLUE LED */
        TM_LIS302DL_LIS3DSH_Init(TM_LIS3DSH_Sensitivity_2G, TM_LIS3DSH_Filter_800Hz);   /* Initialize LIS3DSH */
    }
    else
    {
        while (1)
        {
    	    /* Device is not recognized */
        };
    }
  Delayms(1000);
}
