#include "string.h"
#include "play_FILE.h"
#include "MP3_play.h"
#include "tm_stm32f4_fatfs.h"
#include "tm_stm32f4_usb_msc_host.h"

FIL cwSFFile;
char FileReadBuffer[FILE_READ_BUFFER_SIZE];
volatile int FBytesLeft;
char *cwSFReadPtr;
char direction = 1;

const char *cwSFGetFilenameExt(const char *filename) {
  const char *dot = strrchr(filename, '.');
  if(!dot || dot == filename) return "";
  return dot + 1;
}

FRESULT playFromUSB(const char* path) {
  FATFS USB_Fs;
  FRESULT res;
  FILINFO fno;
  DIR dir;
  char *fn;

  unsigned int index_of_song = 0,k = 0;
  static char num_of_songs;
  char buffer[200];
  char buffer33[256][16];

  if (TM_USB_MSCHOST_Device() != TM_USB_MSCHOST_Result_Connected)
    return 0;
  if (f_mount(&USB_Fs, "1:", 1) != FR_OK)
    return 0;
  
  res = f_opendir(&dir, path); /* Open the directory */
  f_readdir(&dir, &fno);
  fn = fno.fname;
  sprintf(buffer, "%s/%s", path, fn);
  for(k = 0; k < 16; k++)
  {
	  buffer33[index_of_song][k]=buffer[k];
  }
  index_of_song++;
  while(fno.fname[0] != 0){ /* store all files in USB to buffer for playing - while not end of file*/
	  f_readdir(&dir, &fno);
	  fn = fno.fname;
	  if (!(fno.fattrib & AM_DIR)) {
		  sprintf(buffer, "%s/%s", path, fn);
		  for(k = 0; k < 16; k++)
		  {
			  buffer33[index_of_song][k]=buffer[k];
		  }
		  index_of_song++;
	  }
  }
  num_of_songs = index_of_song;
  index_of_song = 0;
  if (res == FR_OK) {
    while(1) /* This is basicly the "main" code, where songs are played in order or backwards. */
    {        /* The program is looped here */
       if(direction == 0)
       {
          if(index_of_song > num_of_songs)
          {
        	  index_of_song = 0;
          }
       }
       else
       {
    	   if(index_of_song > num_of_songs) /* underflow, not correct solution, but works when there is no more than 256 songs in directory*/
    	   {                    /* Todo: find better solution than store all songs in memmory - its good soluton for LCD menu thou */
    		   index_of_song = num_of_songs;
    	   }
       }
        // Check if it is an mp3 file
        if (strcasecmp("mp3", cwSFGetFilenameExt(buffer33[index_of_song])) == 0)
        {
          MP3PlayFile(buffer33[index_of_song]);
        }
        if(direction == 0)
        {
            index_of_song++;
        }
        else
        {
            index_of_song--;
        }
      }

  }
  
  return res;
}
